(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    125051,       3648]
NotebookOptionsPosition[    113041,       3277]
NotebookOutlinePosition[    116421,       3373]
CellTagsIndexPosition[    115646,       3352]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\</home/nzoltan/Zoli/1\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<l:/apus/gabor/butools/mathematica/butoolsmathematica/\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", "dir"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"$Path", ";"}]}], "Input",
 CellChangeTimes->{{3.53156744659375*^9, 3.531567448953125*^9}, 
   3.531648767424918*^9, {3.532162644978945*^9, 3.532162695679798*^9}, {
   3.5321627962065444`*^9, 3.532162879312196*^9}, 3.5321734886808543`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", "\"\<BuTools`Utilities`\>\""}], "\[IndentingNewLine]", 
 RowBox[{"Names", "[", "\"\<BuTools`Utilities`*\>\"", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"BuToolsVerbose\"\>", ",", "\<\"CheckGenerator\"\>", 
   ",", "\<\"CheckMAP\"\>", ",", "\<\"CheckME\"\>", ",", "\<\"CheckPH\"\>", 
   ",", "\<\"CheckProbMatrix\"\>", ",", "\<\"CheckProbVector\"\>", 
   ",", "\<\"CheckRAP\"\>", ",", "\<\"CheckSubProbVector\"\>", 
   ",", "\<\"CheckTransientGenerator\"\>", 
   ",", "\<\"CheckTransientProbMatrix\"\>", ",", "\<\"CRPSolve\"\>", 
   ",", "\<\"CTMCSolve\"\>", ",", "\<\"DRPSolve\"\>", 
   ",", "\<\"DTMCSolve\"\>", ",", "\<\"ElementaryStep\"\>", 
   ",", "\<\"ErrorMinimize\"\>", ",", "\<\"KroneckerSum\"\>", 
   ",", "\<\"MatrixCopy\"\>", ",", "\<\"MomsToNormMoms\"\>", 
   ",", "\<\"MomsToReducedmoms\"\>", ",", "\<\"NormMomsToMoms\"\>", 
   ",", "\<\"RationalToMarkovian\"\>", ",", "\<\"ReducedmomsToMoms\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.528606796737525*^9, 3.528617070032842*^9, 3.530963253448191*^9, 
   3.530963429902793*^9, 3.531048387178524*^9, 3.531474993330197*^9, 
   3.531567450609375*^9, 3.531648771782999*^9, 3.53208622633853*^9, {
   3.5321626801179953`*^9, 3.53216269150811*^9}, {3.5321628496572742`*^9, 
   3.5321628910147967`*^9}, 3.532170219759511*^9, {3.532170374800432*^9, 
   3.5321703803783426`*^9}, 3.532170842126236*^9, 3.5322317456073084`*^9, 
   3.54613993575*^9, 3.546165882359375*^9, 3.546168790265625*^9, 
   3.5461688210625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", "\"\<BuTools`PH`\>\""}], "\[IndentingNewLine]", 
 RowBox[{"Names", "[", "\"\<BuTools`PH`*\>\"", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"APHFrom3Moments\"\>", ",", "\<\"APHRepresentation\"\>", 
   ",", "\<\"Appie\"\>", ",", "\<\"CheckMEPositiveDensity\"\>", 
   ",", "\<\"ME3Canonical\"\>", ",", "\<\"ME3member\"\>", 
   ",", "\<\"MEContOrder\"\>", ",", "\<\"MEDensity\"\>", 
   ",", "\<\"MEFromMoments\"\>", ",", "\<\"MEMoments\"\>", 
   ",", "\<\"MEObsOrder\"\>", ",", "\<\"MEOrderFromMoments\"\>", 
   ",", "\<\"METoPH\"\>", ",", "\<\"MomentsFromME\"\>", 
   ",", "\<\"MomentsFromPH\"\>", ",", "\<\"MonocyclicRepresentation\"\>", 
   ",", "\<\"PH2Canonical\"\>", ",", "\<\"PH3Canonical\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.528606798046929*^9, 3.528617071033965*^9, 
  3.53096325443466*^9, 3.530963431079593*^9, 3.531048388171839*^9, 
  3.531474994660252*^9, 3.531567452328125*^9, 3.531648772712308*^9, 
  3.532086227583045*^9, 3.5321628924678564`*^9, 3.532170225134304*^9, 
  3.5321703818782854`*^9, 3.5321708449230037`*^9, 3.5322317466695843`*^9, 
  3.54613993634375*^9, 3.546165883078125*^9, 3.54616879125*^9, 
  3.5461688220625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", "\"\<BuTools`MAP`\>\""}], "\[IndentingNewLine]", 
 RowBox[{"Names", "[", "\"\<BuTools`MAP`*\>\"", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"LagCorrelationsFromRAP\"\>", 
   ",", "\<\"LagkJointMomentsFromRAP\"\>", ",", "\<\"MAP2Canonical\"\>", 
   ",", "\<\"MAP2CanonicalExplicit\"\>", 
   ",", "\<\"MarginalMomentsFromMAP\"\>", 
   ",", "\<\"MarginalMomentsFromRAP\"\>", ",", "\<\"RAPContMinimize\"\>", 
   ",", "\<\"RAPFromMoments\"\>", 
   ",", "\<\"RAPFromMomentsAndCorrelations\"\>", ",", "\<\"RAPMinimize\"\>", 
   ",", "\<\"RAPObsMinimize\"\>", ",", "\<\"RAPToMAP\"\>", 
   ",", "\<\"StairCase\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.52860679893323*^9, 3.528617071877282*^9, 3.530963255414592*^9, 
   3.530963432139223*^9, 3.531048389053681*^9, 3.531474995751901*^9, 
   3.531567452953125*^9, 3.531648773468164*^9, 3.53208622867956*^9, 
   3.532163075194045*^9, 3.532169374448222*^9, 3.5321703838000865`*^9, 
   3.53217084618858*^9, 3.5322317473725605`*^9, 3.546139936953125*^9, 
   3.546165883703125*^9, {3.546168793375*^9, 3.546168822890625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", "\"\<BuTools`SpecialProcesses`\>\""}], "\[IndentingNewLine]", 
 RowBox[{"Names", "[", "\"\<BuTools`SpecialProcesses`*\>\"", "]"}]}], "Input",\

 CellChangeTimes->{{3.528534298954556*^9, 3.528534314577718*^9}, {
  3.546139938078125*^9, 3.546139941109375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"GammaijkMomentsFromRBT\"\>", 
   ",", "\<\"Lag1JointMomentsFromMRAP\"\>", 
   ",", "\<\"LagkJointMomentsFromTRAP\"\>", ",", "\<\"MomentsFromMRAP\"\>", 
   ",", "\<\"MomentsFromRBT\"\>", ",", "\<\"MomentsFromTRAP\"\>", 
   ",", "\<\"MRAPContMinimize\"\>", ",", "\<\"MRAPFromMoments\"\>", 
   ",", "\<\"MRAPMinimize\"\>", ",", "\<\"MRAPObsMinimize\"\>", 
   ",", "\<\"MRAPToMMAP\"\>", ",", "\<\"MStairCase\"\>", 
   ",", "\<\"RBTContMinimize\"\>", ",", "\<\"RBTFromMoments\"\>", 
   ",", "\<\"RBTMinimize\"\>", ",", "\<\"RBTObsMinimize\"\>", 
   ",", "\<\"RBTToMBT\"\>", ",", "\<\"TRAPContMinimize\"\>", 
   ",", "\<\"TRAPFromMoments\"\>", ",", "\<\"TRAPMinimize\"\>", 
   ",", "\<\"TRAPObsMinimize\"\>", ",", "\<\"TRAPToTMAP\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.528606806266494*^9, 3.528617072778643*^9, 3.528617742710542*^9, 
   3.530963256779765*^9, 3.530963432813859*^9, 3.531048390558664*^9, 
   3.531474997163173*^9, {3.531475036779257*^9, 3.53147505486494*^9}, 
   3.53156745771875*^9, 3.53164877414148*^9, 3.532086229902602*^9, 
   3.5321630777251816`*^9, 3.532169382291671*^9, 3.532170388659275*^9, 
   3.5321708504384165`*^9, 3.5322317483567276`*^9, 3.5389096940625*^9, 
   3.546139941640625*^9, 3.546165884375*^9, {3.546168797234375*^9, 
   3.546168823765625*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"===", "===", "===", "===", "===", 
   RowBox[{
    RowBox[{
    "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
     "MARKED", " ", "OR", " ", "BATCH", " ", "MARKOVIAN", " ", "ARRIVAL", " ",
       "PROCESS", " ", "RELATED", " ", "FUNCTIONS"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "===", "===", "==="}], "=", 
    RowBox[{"=", 
     RowBox[{"=", 
      RowBox[{
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
        "==="}], "="}]}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.5321633124021673`*^9, 3.5321633845551853`*^9}, {
  3.532163789615163*^9, 3.532163826504135*^9}, {3.5321714465249014`*^9, 
  3.5321714515090847`*^9}, {3.5321718164481955`*^9, 3.532171852681179*^9}, {
  3.5321735114299808`*^9, 3.5321735603343525`*^9}, {3.5321735997390895`*^9, 
  3.5321736043951607`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MRAPMinimize"}]], "Input",
 CellChangeTimes->{{3.530963274797804*^9, 3.530963277299097*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPMinimize [ vector of matrix0, matrix1, ... matrixK ] -> [ \
vector of matrix0, matrix1, ... matrixK ] : Computes a minimal representation \
of an MRAP using the staircase method by eliminating the redundancy caused by \
the initial vector and by the closing vector.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.53217085765689*^9},
 CellTags->"Info3532174457-7921268"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MRAPObsMinimize"}]], "Input",
 CellChangeTimes->{{3.530963284047641*^9, 3.530963285668582*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPObsMinimize [ vector of matrix0, matrix1, ... matrixK ] -> \
[ vector of matrix0, matrix1, ... matrixK ] : Computes a minimal \
representation of an MRAP using the staircase methor by eliminating the \
redundancy caused by the initial vector.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellChangeTimes->{3.532170859734935*^9},
 CellTags->"Info3532174459-6645394"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MRAPContMinimize"}]], "Input",
 CellChangeTimes->{{3.530963290860687*^9, 3.530963293763778*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPContMinimize [ vector of matrix0, matrix1, ... matrixK ] \
-> [ vector of matrix0, matrix1, ... matrixK ] : Computes a minimal \
representation of an MRAP using the staircase methor by eliminating the \
redundancy caused by the closing vector.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellChangeTimes->{3.5321708612036285`*^9},
 CellTags->"Info3532174460-6629914"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MStairCase"}]], "Input",
 CellChangeTimes->{{3.530963298241312*^9, 3.530963301509074*^9}}],

Cell[BoxData[
 StyleBox["\<\"MStairCase [ vector of matrix0, matrix1, ... matrixK, closing \
vector ] -> [ size, similarity matrix ] : Computes a smaller representation \
of an MRAP using staircase algorithm.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.532170872671938*^9},
 CellTags->"Info3532174472-7773575"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"d0", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "5."}], "1", "0"},
      {"3", 
       RowBox[{"-", "3"}], "0"},
      {"1", "1", 
       RowBox[{"-", "5"}]}
     }], ")"}]}], ";", 
  RowBox[{"d1", "=", 
   RowBox[{"(", GridBox[{
      {"0", "0", "4"},
      {"0", "0", "0"},
      {"1", "1", "1"}
     }], ")"}]}], ";", 
  RowBox[{"ivec", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"1", "/", "7"}], 
       RowBox[{"1", "/", "7"}], 
       RowBox[{"5", "/", "7"}]}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"XMX", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Transpose", "[", "d0", "]"}], ",", 
     RowBox[{"Transpose", "[", "d1", "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"MStairCase", "[", 
  RowBox[{"XMX", ",", 
   RowBox[{"Transpose", "[", "ivec", "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5322306492639627`*^9, 3.532230689122572*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.2592592592592589`", ",", "0.740740740740741`", ",", 
       RowBox[{"-", "0.7071067811865475`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.25925925925925924`", ",", "0.7407407407407414`", ",", 
       "0.7071067811865476`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.2962962962962963`", ",", 
       RowBox[{"-", "0.29629629629629645`"}], ",", 
       "5.936006894358137`*^-18"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.530963313143027*^9, 3.53156751271875*^9, 
  3.531648920012299*^9, 3.5321708785935855`*^9, 3.532231753652484*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"XMX", "=", 
   RowBox[{"{", 
    RowBox[{"d0", ",", "d1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MRAPContMinimize", "[", "XMX", "]"}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MRAPObsMinimize", "[", "XMX", "]"}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MRAPMinimize", "[", "XMX", "]"}], "//", "Chop"}]}], "Input",
 CellChangeTimes->{{3.5322307152470703`*^9, 3.532230716434548*^9}, {
  3.532231724799204*^9, 3.532231728032896*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5.`"}], ",", "1.`", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.`", ",", 
       RowBox[{"-", "3.`"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.`", ",", "1.`", ",", 
       RowBox[{"-", "5.`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.530963323791096*^9, 3.531567514296875*^9, 
  3.531648921201542*^9, 3.5321708812028604`*^9, 3.532231761760146*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "4.407407407407407`"}], ",", "1.6931216931216935`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8425925925925923`", ",", 
       RowBox[{"-", "2.5925925925925926`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2.0370370370370363`", ",", "0.6772486772486777`"}], "}"}], ",",
      
     RowBox[{"{", 
      RowBox[{"2.7870370370370363`", ",", 
       RowBox[{"-", "1.0370370370370368`"}]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.530963323791096*^9, 3.531567514296875*^9, 
  3.531648921201542*^9, 3.5321708812028604`*^9, 3.5322317617913895`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "4.407407407407407`"}], ",", "1.6931216931216935`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8425925925925923`", ",", 
       RowBox[{"-", "2.5925925925925926`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2.0370370370370363`", ",", "0.6772486772486777`"}], "}"}], ",",
      
     RowBox[{"{", 
      RowBox[{"2.7870370370370363`", ",", 
       RowBox[{"-", "1.0370370370370368`"}]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.530963323791096*^9, 3.531567514296875*^9, 
  3.531648921201542*^9, 3.5321708812028604`*^9, 3.532231761822633*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"d0", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "6."}], "0", "0"},
      {"0", 
       RowBox[{"-", "5"}], "2"},
      {"0", "0", 
       RowBox[{"-", "3"}]}
     }], ")"}]}], ";", 
  RowBox[{"d1", "=", 
   RowBox[{"(", GridBox[{
      {"1", "0", "5"},
      {"0", "1", "1"},
      {"1", "0", "1"}
     }], ")"}]}], ";", 
  RowBox[{"d2", "=", 
   RowBox[{"(", GridBox[{
      {"0", "0", "0"},
      {"0", "1", "0"},
      {"0", "0", "1"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"XMX", "=", 
   RowBox[{"{", 
    RowBox[{"d0", ",", "d1", ",", "d2"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MRAPContMinimize", "[", "XMX", "]"}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MRAPObsMinimize", "[", "XMX", "]"}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MRAPMinimize", "[", "XMX", "]"}], "//", "Chop"}]}], "Input",
 CellChangeTimes->{{3.5322307960580187`*^9, 3.5322308160420103`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "6.`"}], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "5.`"}], ",", "2.`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", "3.`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.530963447394213*^9, 3.531567517375*^9, 
  3.531648923301675*^9, 3.532170883405901*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3.413793103448276`"}], ",", 
       RowBox[{"-", "0.44334975369458135`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2.4137931034482767`"}], ",", 
       RowBox[{"-", "5.586206896551724`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3.06896551724138`", ",", "0.07389162561576329`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"9.735632183908047`", ",", 
       RowBox[{"-", "1.06896551724138`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.8620689655172412`", ",", 
       RowBox[{"-", "0.1477832512315271`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.8045977011494252`"}], ",", "0.13793103448275865`"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.530963447394213*^9, 3.531567517375*^9, 
  3.531648923301675*^9, 3.5321708834371495`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3.413793103448276`"}], ",", 
       RowBox[{"-", "0.44334975369458135`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2.4137931034482767`"}], ",", 
       RowBox[{"-", "5.586206896551724`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3.06896551724138`", ",", "0.07389162561576329`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"9.735632183908047`", ",", 
       RowBox[{"-", "1.06896551724138`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.8620689655172412`", ",", 
       RowBox[{"-", "0.1477832512315271`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.8045977011494252`"}], ",", "0.13793103448275865`"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.530963447394213*^9, 3.531567517375*^9, 
  3.531648923301675*^9, 3.532170883468398*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Lag1JointMomentsFromMRAP"}]], "Input",
 CellChangeTimes->{{3.5321712816562324`*^9, 3.532171283171799*^9}}],

Cell[BoxData[
 StyleBox["\<\"Lag1JointMomentsFromMRAP [ vector of matrix0, matrix1, ... \
matrixK] -> [ vector of jointmomentsmatrix1, ... jointmomentsmatrixK ] : \
calculates the defective joint moments of (X0^(k))^i X1^j (type k) for i,j=0 \
to n-1, k=1 to K and returns the result in vector of n x n  matrices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5321714203384066`*^9},
 CellTags->"Info3532175020-7332988"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MomentsFromMRAP"}]], "Input",
 CellChangeTimes->{{3.531475080451182*^9, 3.53147508053942*^9}}],

Cell[BoxData[
 StyleBox["\<\"MomentsFromMRAP [ vector of matrix0, matrix1, ... matrixK ] -> \
[ moments ] : Calculates the first 2n-1 marginal moments of the MRAP of size \
n.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.532171423088301*^9},
 CellTags->"Info3532175022-1876917"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MRAPFromMoments"}]], "Input",
 CellChangeTimes->{{3.531475070161407*^9, 3.53147507041571*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPFromMoments [ marginal moments, vector of \
jointmomentsmatrix1, ... jointmomentsmatrixK ] -> [ vector of matrix0, \
matrix1, ... matrixK ] : Calculates an MRAP representation based on 2n-1 \
marginal moments and the vector of nxn matrices of the lag1 joint \
moments.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5321710289784355`*^9},
 CellTags->"Info3532174628-1638735"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"d0", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5."}], ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "8"}], ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", 
       RowBox[{"-", "4"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", 
       RowBox[{"-", "9"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1.", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "2."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"XMX", "=", 
   RowBox[{"{", 
    RowBox[{"d0", ",", "d1", ",", "d2"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"moms", "=", 
  RowBox[{"MomentsFromMRAP", "[", "XMX", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"JMOM", "=", 
   RowBox[{"Lag1JointMomentsFromMRAP", "[", "XMX", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"YMX", "=", 
  RowBox[{"MRAPFromMoments", "[", 
   RowBox[{"moms", ",", "JMOM"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"moms", "-", 
   RowBox[{"MomentsFromMRAP", "[", "YMX", "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"JMOM", "-", 
   RowBox[{"Lag1JointMomentsFromMRAP", "[", "YMX", "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.532163730430314*^9, 3.532163735836322*^9}, {
   3.5321719448807635`*^9, 3.5321719836605244`*^9}, 3.5321720731727123`*^9, {
   3.5321722673527555`*^9, 3.532172314179082*^9}, {3.5321723895980606`*^9, 
   3.532172393472912*^9}, {3.5321724375962176`*^9, 3.5321725905903425`*^9}, {
   3.532172660759523*^9, 3.53217267449337*^9}, {3.532172934561508*^9, 
   3.5321729382332425`*^9}, {3.532172983137768*^9, 3.532173000855838*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.34246575342465757`", ",", "0.25053639214391815`", ",", 
   "0.2827096943168425`", ",", "0.42984404959582057`", ",", 
   "0.8199855548792178`", ",", "1.8794706921737607`", ",", 
   "5.0280196843561145`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.531475139323069*^9, 3.531567465796875*^9, 3.53164893014119*^9, 
   3.532163736680034*^9, 3.532171428119358*^9, {3.532171961005144*^9, 
   3.532171984597988*^9}, 3.5321722858051715`*^9, 3.5321723939260197`*^9, 
   3.532172444674071*^9, 3.532172591902792*^9, 3.532172663743783*^9, 
   3.5321729393738236`*^9, 3.5321729844658422`*^9, 3.53891006115625*^9, 
   3.538910285734375*^9, 3.538910668859375*^9, 3.5389108381875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.4246575342465754`", ",", "0.1376936316695353`", ",", 
       "0.09846252851793039`", ",", "0.11014747052469348`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.14474335698960225`", ",", "0.045895225918172966`", ",", 
       "0.03245160583591457`", ",", "0.03613790541826484`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.10537886343667646`", ",", "0.03308826397741821`", ",", 
       "0.023274429877782624`", ",", "0.02586095232804516`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.11861561254489812`", ",", "0.037106458188479616`", ",", 
       "0.026047660697468132`", ",", "0.028916628859568035`"}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.5753424657534246`", ",", "0.20477212175512224`", ",", 
       "0.15207386362598777`", ",", "0.17256222379214903`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.1977223964350553`", ",", "0.07140357340994849`", ",", 
       "0.05333723184363527`", ",", "0.060669280105267176`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.1451575287072417`", ",", "0.052611741457382205`", ",", 
       "0.03935839603147918`", ",", "0.04479888459418833`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.16409408177194434`", ",", "0.0595200543887445`", ",", 
       "0.04454096564977577`", ",", "0.05070648680573974`"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.531475139323069*^9, 3.531567465796875*^9, 3.53164893014119*^9, 
   3.532163736680034*^9, 3.532171428119358*^9, {3.532171961005144*^9, 
   3.532171984597988*^9}, 3.5321722858051715`*^9, 3.5321723939260197`*^9, 
   3.532172444674071*^9, 3.532172591902792*^9, 3.532172663743783*^9, 
   3.5321729393738236`*^9, 3.5321729844658422`*^9, 3.53891006115625*^9, 
   3.538910285734375*^9, 3.538910668859375*^9, 3.5389108381875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "6.7126047620380955`"}], ",", "32.98912831904456`", ",", 
       RowBox[{"-", "108.70525382294765`"}], ",", "77.98325080838424`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.8704043653221694`"}], ",", 
       RowBox[{"-", "8.34051387619419`"}], ",", "25.26769863995573`", ",", 
       RowBox[{"-", "19.012581520225524`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.6598231785588543`"}], ",", "3.07388225315923`", ",", 
       RowBox[{"-", "16.542814011640374`"}], ",", "11.226649030443047`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.6597724561189758`"}], ",", "3.076631625173058`", ",", 
       RowBox[{"-", "10.91488463012266`"}], ",", "5.5959324903456755`"}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.013283853596623806`", ",", "1.3997663106019929`", ",", 
       "10614.987496871501`", ",", 
       RowBox[{"-", "10614.586300456896`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.5708242597956629`", ",", "2.374727689660206`", ",", 
       "213.52619680576026`", ",", 
       RowBox[{"-", "215.18737755995244`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.5429570066281815`", ",", "1.2113764275843586`", ",", 
       "2588.069800488651`", ",", 
       RowBox[{"-", "2588.6063155885786`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.5428911972559012`", ",", "1.2103739583165953`", ",", 
       "2588.9223573962227`", ",", 
       RowBox[{"-", "2589.457812081091`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1.6273260796512259`", ",", "3.0204406171982447`", ",", 
       "15736.406475104392`", ",", 
       RowBox[{"-", "15738.423008922487`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.04552323489723168`", ",", 
       RowBox[{"-", "1.4984031210472069`"}], ",", 
       RowBox[{"-", "1644.9970179880038`"}], ",", "1648.1213278006762`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.24386966283384506`", ",", 
       RowBox[{"-", "0.5544888941146918`"}], ",", 
       RowBox[{"-", "1871.7270968239754`"}], ",", "1873.7220036275685`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.24393463781131935`", ",", 
       RowBox[{"-", "0.5535860604036353`"}], ",", 
       RowBox[{"-", "1871.6042399583384`"}], ",", "1873.5981738809496`"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.531475139323069*^9, 3.531567465796875*^9, 3.53164893014119*^9, 
   3.532163736680034*^9, 3.532171428119358*^9, {3.532171961005144*^9, 
   3.532171984597988*^9}, 3.5321722858051715`*^9, 3.5321723939260197`*^9, 
   3.532172444674071*^9, 3.532172591902792*^9, 3.532172663743783*^9, 
   3.5321729393738236`*^9, 3.5321729844658422`*^9, 3.53891006115625*^9, 
   3.538910285734375*^9, 3.538910668859375*^9, 3.53891083821875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", 
   RowBox[{"-", "3.511736457184611`*^-10"}], ",", 
   RowBox[{"-", "1.280771599887487`*^-9"}], ",", 
   RowBox[{"-", "4.611648618535469`*^-9"}], ",", 
   RowBox[{"-", "1.7229051074707513`*^-8"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.531475139323069*^9, 3.531567465796875*^9, 3.53164893014119*^9, 
   3.532163736680034*^9, 3.532171428119358*^9, {3.532171961005144*^9, 
   3.532171984597988*^9}, 3.5321722858051715`*^9, 3.5321723939260197`*^9, 
   3.532172444674071*^9, 3.532172591902792*^9, 3.532172663743783*^9, 
   3.5321729393738236`*^9, 3.5321729844658422`*^9, 3.53891006115625*^9, 
   3.538910285734375*^9, 3.538910668859375*^9, 3.53891083825*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "9.481063079075369`*^-8", ",", "1.0498184635499008`*^-7", ",",
        "1.3718431374210027`*^-7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "3.0077807022799163`*^-8", ",", "3.3307795424541986`*^-8", 
       ",", "4.352884180880423`*^-8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "2.3778198354751368`*^-8", ",", "2.6333545691259452`*^-8", 
       ",", "3.441544834531518`*^-8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1.2588900755172716`*^-10"}], ",", 
       "2.8251895864417342`*^-8", ",", "3.129493433146058`*^-8", ",", 
       "4.090184014399201`*^-8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "9.485430521594118`*^-8"}], ",", 
       RowBox[{"-", "1.050097524213367`*^-7"}], ",", 
       RowBox[{"-", "1.3727186531919955`*^-7"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "7.359932799322344`*^-8"}], ",", 
       RowBox[{"-", "8.145147455118629`*^-8"}], ",", 
       RowBox[{"-", "1.064411453421954`*^-7"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "6.68063374897887`*^-8"}], ",", 
       RowBox[{"-", "7.393524947135743`*^-8"}], ",", 
       RowBox[{"-", "9.661548529965591`*^-8"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "8.089674055633544`*^-8"}], ",", 
       RowBox[{"-", "8.952926306565745`*^-8"}], ",", 
       RowBox[{"-", "1.1699161562434002`*^-7"}]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.531475139323069*^9, 3.531567465796875*^9, 3.53164893014119*^9, 
   3.532163736680034*^9, 3.532171428119358*^9, {3.532171961005144*^9, 
   3.532171984597988*^9}, 3.5321722858051715`*^9, 3.5321723939260197`*^9, 
   3.532172444674071*^9, 3.532172591902792*^9, 3.532172663743783*^9, 
   3.5321729393738236`*^9, 3.5321729844658422`*^9, 3.53891006115625*^9, 
   3.538910285734375*^9, 3.538910668859375*^9, 3.538910838265625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MRAPToMMAP"}]], "Input",
 CellChangeTimes->{{3.5321715018977747`*^9, 3.5321715093193645`*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPToMMAP [  vector of matrix0, matrix1, ... matrixK ] -> [  \
vector of matrix0, matrix1, ... matrixK ] : Similarity transforms the \
non-Markovian representation of a marked rational arrival process to the \
Markovian representation of the same size if possibe\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.538910840125*^9},
 CellTags->"Info3538914439-9668823"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"YMX", "=", 
  RowBox[{"MRAPToMMAP", "[", "YMX", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"moms", "-", 
   RowBox[{"MomentsFromMRAP", "[", "YMX", "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"JMOM", "-", 
   RowBox[{"Lag1JointMomentsFromMRAP", "[", "YMX", "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{
  3.538910206671875*^9, {3.5389103113125*^9, 3.538910313046875*^9}, {
   3.538910664578125*^9, 3.538910665109375*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"No MARKOVIAN representation is found in \"\>", 
   "\[InvisibleSpace]", "98", 
   "\[InvisibleSpace]", "\<\" iterations !!!\"\>"}],
  SequenceForm[
  "No MARKOVIAN representation is found in ", 98, " iterations !!!"],
  Editable->False]], "Print",
 CellChangeTimes->{3.532172958919948*^9, 3.538910127109375*^9, 
  3.538910209390625*^9, 3.538910313609375*^9, 3.538910559125*^9, 
  3.53891067571875*^9, 3.538910844609375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5.541273615515206`"}], ",", "1.5797392925457387`", ",", 
       RowBox[{"-", "0.31965868276458953`"}], ",", "1.21712339213662`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.008294119892326361`", ",", 
       RowBox[{"-", "9.305339117311432`"}], ",", "0.8683525365420124`", ",", 
       "4.238983460602249`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.2241120816999162`"}], ",", "2.0491726385131006`", ",", 
       
       RowBox[{"-", "6.731430680446673`"}], ",", 
       RowBox[{"-", "0.0003033598275827276`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.9320784809617377`", ",", "0.9250914460493059`", ",", 
       "1.6549495634997182`", ",", 
       RowBox[{"-", "4.4219567462536675`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.12432251835307456`", ",", 
       RowBox[{"-", "0.24370611796512304`"}], ",", "0.44256607410913906`", 
       ",", "1.3071582174909175`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1.7156697408492674`", ",", "0.4823728304353337`", ",", 
       "0.5094592523215481`", ",", 
       RowBox[{"-", "0.2572925991808764`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.12590575551376668`"}], ",", "0.9457065213669383`", ",",
        "0.5509304087224731`", ",", "0.4672233731674023`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.11477051399360136`"}], ",", 
       RowBox[{"-", "0.22155179106475603`"}], ",", "0.6352562902891528`", ",",
        
       RowBox[{"-", "0.15762580669439746`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.05547232867090807`", ",", "0.9755403136293692`", ",", 
       "0.09429378890981144`", ",", "0.3084224848343292`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.2786814631031419`"}], ",", 
       RowBox[{"-", "0.03843443963827352`"}], ",", 
       RowBox[{"-", "0.2373268015608936`"}], ",", "2.293942480903407`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.19483529565139446`", ",", "0.4468751493919088`", ",", 
       "1.9214666429377916`", ",", "0.5055418503146034`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9105775350696312`", ",", 
       RowBox[{"-", "0.3738443301530209`"}], ",", "0.17030038884148627`", ",",
        "0.061495483607720246`"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5321729589355726`*^9, 3.53891012725*^9, 
  3.538910209390625*^9, 3.538910313640625*^9, 3.538910559125*^9, 
  3.53891067571875*^9, 3.538910844625*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"CheckRAP: A rowsum of matrix0+matrix1 is not 0! \
(precision:\"\>", "\[InvisibleSpace]", "1.`*^-10", 
   "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm[
  "CheckRAP: A rowsum of matrix0+matrix1 is not 0! (precision:", 1.*^-10, 
   ")"],
  Editable->False]], "Print",
 CellChangeTimes->{3.532172958919948*^9, 3.538910127109375*^9, 
  3.538910209390625*^9, 3.538910313609375*^9, 3.538910559125*^9, 
  3.53891067571875*^9, 3.538910844640625*^9}],

Cell[BoxData["\<\"Marginal moments of improper RAP!!\"\>"], "Print",
 CellChangeTimes->{3.532172958919948*^9, 3.538910127109375*^9, 
  3.538910209390625*^9, 3.538910313609375*^9, 3.538910559125*^9, 
  3.53891067571875*^9, 3.53891084465625*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", 
   RowBox[{"-", "3.511481105888947`*^-10"}], ",", 
   RowBox[{"-", "1.2807194194053295`*^-9"}], ",", 
   RowBox[{"-", "4.611521386976847`*^-9"}], ",", 
   RowBox[{"-", "1.7228691362447535`*^-8"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5321729589355726`*^9, 3.53891012725*^9, 
  3.538910209390625*^9, 3.538910313640625*^9, 3.538910559125*^9, 
  3.53891067571875*^9, 3.5389108446875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "9.481045476489314`*^-8", ",", "1.0498164761119089`*^-7", ",",
        "1.3718408721496989`*^-7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "3.0077767193548155`*^-8", ",", "3.330774451387741`*^-8", ",",
        "4.3528784299251555`*^-8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "2.377816871179661`*^-8", ",", "2.6333508588993748`*^-8", ",",
        "3.441540447762792`*^-8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1.258328025111055`*^-10"}], ",", 
       "2.8251875699991658`*^-8", ",", "3.1294900254552616`*^-8", ",", 
       "4.090180076923855`*^-8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "9.485414273480153`*^-8"}], ",", 
       RowBox[{"-", "1.0500958005921213`*^-7"}], ",", 
       RowBox[{"-", "1.3727165817933873`*^-7"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "7.359920478622328`*^-8"}], ",", 
       RowBox[{"-", "8.145132916748121`*^-8"}], ",", 
       RowBox[{"-", "1.0644097747647407`*^-7"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "6.680622489929622`*^-8"}], ",", 
       RowBox[{"-", "7.393512917869272`*^-8"}], ",", 
       RowBox[{"-", "9.66153446205209`*^-8"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "8.089662341392856`*^-8"}], ",", 
       RowBox[{"-", "8.952912169263305`*^-8"}], ",", 
       RowBox[{"-", "1.1699145192195504`*^-7"}]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5321729589355726`*^9, 3.53891012725*^9, 
  3.538910209390625*^9, 3.538910313640625*^9, 3.538910559125*^9, 
  3.53891067571875*^9, 3.538910844703125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"d0", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5."}], ",", 
       RowBox[{"0.1", "+", "x"}], ",", "0.9", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "8"}], ",", "0.9", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9", ",", "0.1", ",", 
       RowBox[{"-", "4"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", 
       RowBox[{"-", "9"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"0.1", "-", "x"}], ",", "0.7", ",", " ", "0.1", ",", "0.1"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1", ",", "1", ",", "1.8", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1", ",", "0.1", ",", "0.1", ",", "0.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.7", ",", "0.1", ",", "0.1", ",", "0.1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.1", ",", "0.1", ",", "0.1", ",", "1.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.8", ",", "0.1", ",", "1", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1", ",", "0.1", ",", "0.7", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1", ",", "1", ",", "0.1", ",", "0.8"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"XMX", "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"d0", ",", "d1", ",", "d2"}], "}"}], "/.", 
   RowBox[{"x", "\[Rule]", "0.18"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"moms", "=", 
   RowBox[{"MomentsFromMRAP", "[", "XMX", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"JMOM", "=", 
    RowBox[{"Lag1JointMomentsFromMRAP", "[", "XMX", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"YMX", "=", 
  RowBox[{"MRAPToMMAP", "[", "XMX", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"moms", "-", 
   RowBox[{"MomentsFromMRAP", "[", "YMX", "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"JMOM", "-", 
   RowBox[{"Lag1JointMomentsFromMRAP", "[", "YMX", "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.532163730430314*^9, 3.532163735836322*^9}, {
   3.5321719448807635`*^9, 3.5321719836605244`*^9}, 3.5321720731727123`*^9, {
   3.5321722673527555`*^9, 3.5321723549743905`*^9}, {3.5321726242140512`*^9, 
   3.5321726381666403`*^9}, {3.5321726912583513`*^9, 
   3.5321727350379205`*^9}, {3.5321727847235126`*^9, 3.532172837893346*^9}, 
   3.5321730323702526`*^9, {3.53891077790625*^9, 3.53891078121875*^9}, {
   3.53891082265625*^9, 3.538910824*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5.`"}], ",", "0.28`", ",", "0.9`", ",", "1"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "8"}], ",", "0.9`", ",", "0.1`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9`", ",", "0.1`", ",", 
       RowBox[{"-", "4"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", 
       RowBox[{"-", "9"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.07999999999999999`"}], ",", "0.7`", ",", "0.1`", ",", 
       "0.1`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1`", ",", "1", ",", "1.8`", ",", "0.1`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1`", ",", "0.1`", ",", "0.1`", ",", "0.7`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.7`", ",", "0.1`", ",", "0.1`", ",", "0.1`"}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.1`", ",", "0.1`", ",", "0.1`", ",", "1.7`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.8`", ",", "0.1`", ",", "1", ",", "0.1`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1`", ",", "0.1`", ",", "0.7`", ",", "0.1`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1`", ",", "1", ",", "0.1`", ",", "0.8`"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.532172725335168*^9, 3.5321727425376325`*^9}, {
   3.5321727852703667`*^9, 3.5321728386433167`*^9}, 3.538910690453125*^9, {
   3.53891078240625*^9, 3.5389108244375*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"MARKOVIAN REPRESEANTAION !!!!!\"\>"], "Print",
 CellChangeTimes->{{3.532172725319544*^9, 3.5321727425376325`*^9}, {
   3.5321727853172398`*^9, 3.5321728396120296`*^9}, 3.5389106914375*^9, {
   3.53891078240625*^9, 3.538910825421875*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Found a Markovian representation in \"\>", "\[InvisibleSpace]",
    "29", "\[InvisibleSpace]", "\<\" iterations !!!\"\>"}],
  SequenceForm["Found a Markovian representation in ", 29, " iterations !!!"],
  
  Editable->False]], "Print",
 CellChangeTimes->{{3.532172725319544*^9, 3.5321727425376325`*^9}, {
   3.5321727853172398`*^9, 3.5321728396120296`*^9}, 3.5389106914375*^9, {
   3.53891078240625*^9, 3.538910825421875*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "4.6588163599369805`"}], ",", "0.18989774299061926`", ",",
        "0.9631078645076855`", ",", "0.8457684119542439`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.1033587654034585`", ",", 
       RowBox[{"-", "8.010038854968892`"}], ",", "0.5326567483091977`", ",", 
       "0.006098273065355106`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.2345214434284892`", ",", "0.0926470392104949`", ",", 
       RowBox[{"-", "4.125287918030508`"}], ",", "0.8554526567459105`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.9347634927013307`", ",", "2.214057447490012`", ",", 
       "2.703254470598746`", ",", 
       RowBox[{"-", "9.205856867063613`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.0037170774705302286`", ",", "0.5224496163765293`", ",", 
       "0.14418738532071315`", ",", "0.1801750275823805`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.2091658684567368`", ",", "0.9834142854024329`", ",", 
       "1.9636762390626217`", ",", "0.05967227873978787`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.21186169818081668`", ",", "0.044792538141937975`", ",", 
       "0.11622545245760268`", ",", "0.5984537005424498`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1.0308899663177133`", ",", "0.08217067517472484`", ",", 
       "0.02392865673675754`", ",", "0.01664318466943405`"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.2909290944107276`", ",", "0.024017495319886763`", ",", 
       "0.3119174964931374`", ",", "1.1826491475105285`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "2.438849221051918`", ",", "0.10130375987714996`", ",", 
       "0.6006005180897064`", ",", "0.011242897510528533`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.1114825200151514`", ",", "0.0945837235955334`", ",", 
       "0.6808113575765938`", ",", "0.08445578813552854`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.4197934369745276`", ",", "1.0213364546703265`", ",", 
       "0.13206329359450864`", ",", "0.6269557881355283`"}], "}"}]}], "}"}]}],
   "}"}]], "Output",
 CellChangeTimes->{{3.532172725335168*^9, 3.5321727425376325`*^9}, {
   3.5321727852703667`*^9, 3.5321728386433167`*^9}, 3.538910690453125*^9, {
   3.53891078240625*^9, 3.538910825421875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.532172725335168*^9, 3.5321727425376325`*^9}, {
   3.5321727852703667`*^9, 3.5321728386433167`*^9}, 3.538910690453125*^9, {
   3.53891078240625*^9, 3.5389108254375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.532172725335168*^9, 3.5321727425376325`*^9}, {
   3.5321727852703667`*^9, 3.5321728386433167`*^9}, 3.538910690453125*^9, {
   3.53891078240625*^9, 3.53891082546875*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
    "===", "===", "===", "===", "===", "===", "===", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
   "TRANSIENT", " ", "MARKOVIAN", " ", "ARRIVAL", " ", "PROCESS", " ", 
    "RELATED", " ", "FUNCTIONS"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "===", "===", "===", "===", "===", "===", "===", "===",
    "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
   "=="}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.5321633124021673`*^9, 3.5321633845551853`*^9}, {
  3.532163789615163*^9, 3.532163826504135*^9}, {3.5321735710370665`*^9, 
  3.532173593254964*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TRAPMinimize"}]], "Input",
 CellChangeTimes->{{3.530963274797804*^9, 3.530963277299097*^9}, {
  3.54616889584375*^9, 3.546168896109375*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPMinimize [ vector of matrix0, matrix1, ... matrixK ] -> [ \
vector of matrix0, matrix1, ... matrixK ] : Computes a minimal representation \
of an MRAP using the staircase method by eliminating the redundancy caused by \
the initial vector and by the closing vector.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.53217085765689*^9},
 CellTags->"Info3532174457-7921268"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TRAPObsMinimize"}]], "Input",
 CellChangeTimes->{{3.530963284047641*^9, 3.530963285668582*^9}, {
  3.546168898734375*^9, 3.546168899*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPObsMinimize [ vector of matrix0, matrix1, ... matrixK ] -> \
[ vector of matrix0, matrix1, ... matrixK ] : Computes a minimal \
representation of an MRAP using the staircase methor by eliminating the \
redundancy caused by the initial vector.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellChangeTimes->{3.532170859734935*^9},
 CellTags->"Info3532174459-6645394"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TRAPContMinimize"}]], "Input",
 CellChangeTimes->{{3.530963290860687*^9, 3.530963293763778*^9}, {
  3.5461689020625*^9, 3.546168902359375*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPContMinimize [ vector of matrix0, matrix1, ... matrixK ] \
-> [ vector of matrix0, matrix1, ... matrixK ] : Computes a minimal \
representation of an MRAP using the staircase methor by eliminating the \
redundancy caused by the closing vector.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellChangeTimes->{3.5321708612036285`*^9},
 CellTags->"Info3532174460-6629914"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"non", "-", 
    RowBox[{
    "minimal", " ", "by", " ", "the", " ", "closing", " ", "vector"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Alpha]", " ", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "7"}], "}"}], "/", "10"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"D0", "=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"-", "20"}], "8", "1"},
        {"4", 
         RowBox[{"-", "16"}], "1"},
        {"1", "2", 
         RowBox[{"-", "11"}]}
       }], ")"}]}], ";", 
    RowBox[{"D1", "=", 
     RowBox[{"(", GridBox[{
        {"2", "5", "3"},
        {"3", "4", "3"},
        {"3", "2", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "}"}], "=", 
    RowBox[{"TRAPContMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "}"}], "=", 
    RowBox[{"TRAPObsMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5461689048125*^9, 3.54616900075*^9}, {
  3.546169047421875*^9, 3.546169055859375*^9}, {3.54616909246875*^9, 
  3.5461691590625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.777817459305202`", ",", 
     RowBox[{"-", "0.7778174593052021`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "9.29289321881345`"}], ",", 
       RowBox[{"-", "0.7071067811865497`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.292893218813453`", ",", 
       RowBox[{"-", "13.70710678118655`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"7.488155364689087`", ",", "1.1785113019775797`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"10.04044011451988`", ",", "0.5118446353109141`"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.5461690620625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", "10"], ",", 
     FractionBox["1", "5"], ",", 
     FractionBox["7", "10"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "20"}], ",", "8", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"-", "16"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "11"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "5", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.54616906209375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "}"}], "=", 
  RowBox[{"TRAPMinimize", "[", 
   RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "=", 
   RowBox[{
    RowBox[{"MomentsFromTRAP", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", "=", 
   RowBox[{
    RowBox[{"LagkJointMomentsFromTRAP", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1", ",", "1"}], "]"}], "//", 
    "N"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom1", "=", 
   RowBox[{
    RowBox[{"MomentsFromTRAP", "[", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn1", "=", 
   RowBox[{
    RowBox[{"LagkJointMomentsFromTRAP", "[", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1", ",", "1"}], "]"}], "//", 
    "N"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mom", "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "4"}], "]"}], "]"}], "-", "mom1"}], " ", "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nn", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", ";;", "2"}], ",", 
      RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "-", "nn1"}], " ", "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.546169027046875*^9, 3.546169059984375*^9}, {
  3.5461692374375*^9, 3.546169241796875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9999999999999999`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "10.666666666666668`"}], ",", 
       RowBox[{"-", "0.8333333333333335`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2.6666666666666714`"}], ",", 
       RowBox[{"-", "16.333333333333332`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6.000000000000001`", ",", "0.4999999999999999`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"12.000000000000012`", ",", "1.999999999999999`"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.54616924246875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.5461692425*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.5461692425*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"non", "-", 
    RowBox[{
    "minimal", " ", "by", " ", "the", " ", "initial", " ", "vector"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Alpha]", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "2"}], "}"}], "/", "4"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"D0", "=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"-", "20"}], "4", "3"},
        {"4", 
         RowBox[{"-", "20"}], "1"},
        {"1", "1", 
         RowBox[{"-", "11"}]}
       }], ")"}]}], ";", 
    RowBox[{"D1", "=", 
     RowBox[{"(", GridBox[{
        {"2", "3", "1"},
        {"4", "3", "5"},
        {"1", "1", "2"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "}"}], "=", 
    RowBox[{"TRAPContMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "}"}], "=", 
    RowBox[{"TRAPObsMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5461689048125*^9, 3.54616900075*^9}, {
  3.546169047421875*^9, 3.546169055859375*^9}, {3.54616909246875*^9, 
  3.5461692065625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", "4"], ",", 
     FractionBox["1", "4"], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "20"}], ",", "4", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"-", "20"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", 
       RowBox[{"-", "11"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "3", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.5461690620625*^9, 
  3.546169213265625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9999999999999999`", ",", "2.7755575615628914`*^-17"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "10.666666666666668`"}], ",", 
       RowBox[{"-", "0.8333333333333335`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2.6666666666666714`"}], ",", 
       RowBox[{"-", "16.333333333333332`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6.000000000000001`", ",", "0.4999999999999999`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"12.000000000000012`", ",", "1.999999999999999`"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.5461690620625*^9, 
  3.546169213265625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "}"}], "=", 
  RowBox[{"TRAPMinimize", "[", 
   RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "=", 
   RowBox[{
    RowBox[{"MomentsFromTRAP", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", "=", 
   RowBox[{
    RowBox[{"LagkJointMomentsFromTRAP", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "D1", ",", "1"}], "]"}], "//", 
    "N"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom1", "=", 
   RowBox[{
    RowBox[{"MomentsFromTRAP", "[", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn1", "=", 
   RowBox[{
    RowBox[{"LagkJointMomentsFromTRAP", "[", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "G1", ",", "1"}], "]"}], "//", 
    "N"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mom", "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "4"}], "]"}], "]"}], "-", "mom1"}], " ", "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nn", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", ";;", "2"}], ",", 
      RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "-", "nn1"}], " ", "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.546169027046875*^9, 3.546169059984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9999999999999999`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "10.666666666666668`"}], ",", 
       RowBox[{"-", "0.8333333333333335`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2.6666666666666714`"}], ",", 
       RowBox[{"-", "16.333333333333332`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6.000000000000001`", ",", "0.4999999999999999`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"12.000000000000012`", ",", "1.999999999999999`"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.546169217*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.546169217015625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.546169217015625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MomentsFromTRAP"}]], "Input",
 CellChangeTimes->{{3.528617752204669*^9, 3.528617754393488*^9}, {
  3.528619086409194*^9, 3.528619093077921*^9}, {3.53104844316742*^9, 
  3.531048443354629*^9}}],

Cell[BoxData[
 StyleBox["\<\"MomentsFromTRAP [ vector (1 x n), matrix0 (n x n), matrix1 (n \
x n) ] -> [ moments ] :  returns: defective moments of X0 from 0 to 2n-1\"\>",
   "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.531648901479215*^9},
 CellTags->"Info3531652501-7249867"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "LagkJointMomentsFromTRAP"}]], "Input",
 CellChangeTimes->{{3.528619113026751*^9, 3.528619121156979*^9}, {
   3.531048448855824*^9, 3.531048451608778*^9}, {3.531648842679946*^9, 
   3.531648843124297*^9}, 3.5321638370036645`*^9, {3.5321638947667017`*^9, 
   3.532163898016556*^9}, {3.5321720840472946`*^9, 3.5321720841254168`*^9}}],

Cell[BoxData[
 StyleBox["\<\"LagkJointMomentsFromTRAP [ vector (1 x n), matrix0 (n x n), \
matrix1 (n x n^2), k ] -> [ moments ] : returns: defective joint moments of \
X0^i Xk^j for i,j= 0 to n-1\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.532172084906636*^9},
 CellTags->"Info3532175684-9722049"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TRAPFromMoments"}]], "Input",
 CellChangeTimes->{{3.528619096154072*^9, 3.528619109942392*^9}, {
  3.5321638343944063`*^9, 3.5321638349881296`*^9}}],

Cell[BoxData[
 StyleBox["\<\"TRAPFromMoments [  vector (1 x 2n), matrix0 (n x n) ] -> [ \
vector (1 x n), matrix0 (n x n), matrix1 (n x n) ] :  input: X0 defective \
moments from 0 to 2n-1 + defective joint moments of X0 X1 from 0 to n-1\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5321639147814302`*^9},
 CellTags->"Info3532167514-2990213"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"{", 
    RowBox[{".6", ",", ".4"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d0", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "4."}], "0"},
      {"1", 
       RowBox[{"-", "6"}]}
     }], ")"}]}], ";", 
  RowBox[{"d1", "=", 
   RowBox[{"(", GridBox[{
      {"0", "3"},
      {"3", "0"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"mom", "=", 
  RowBox[{"MomentsFromTRAP", "[", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "d1"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"nn", "=", 
  RowBox[{"LagkJointMomentsFromTRAP", "[", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "d1", ",", "1"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.531048454640055*^9, 3.531048460988635*^9}, {
  3.532163855440338*^9, 3.5321638559559402`*^9}, {3.5321728934849606`*^9, 
  3.5321728935318336`*^9}, {3.5321731680056686`*^9, 3.532173169724353*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.7`", ",", "0.16666666666666666`", ",", "0.08055555555555556`", ",", 
   "0.059027777777777776`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.528617761087156*^9, 3.531048480495203*^9, {3.53156750828125*^9, 
   3.53156752246875*^9}, 3.531648846067039*^9, 3.5316489055128508`*^9, {
   3.532172887703933*^9, 3.532172894328678*^9}, 3.5321731234136314`*^9, 
   3.5321731722398815`*^9, 3.538911102515625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.4625`", ",", "0.10520833333333332`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.10833333333333334`", ",", "0.024305555555555552`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.528617761087156*^9, 3.531048480495203*^9, {3.53156750828125*^9, 
   3.53156752246875*^9}, 3.531648846067039*^9, 3.5316489055128508`*^9, {
   3.532172887703933*^9, 3.532172894328678*^9}, 3.5321731234136314`*^9, 
   3.5321731722398815`*^9, 3.538911102515625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Beta]", ",", "g0", ",", "g1"}], "}"}], "=", 
  RowBox[{"TRAPFromMoments", "[", 
   RowBox[{"mom", ",", "nn"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", " ", "-", 
   RowBox[{"MomentsFromTRAP", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "g1"}], "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "-", 
   RowBox[{"LagkJointMomentsFromTRAP", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "g1", ",", "1"}], "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.531048463516282*^9, 3.531048469224454*^9}, {
  3.5321728976410513`*^9, 3.5321728976879244`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.5099999999999956`", ",", "0.4899999999999914`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "7.900000000000134`"}], ",", "3.390196078431465`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2.1857142857143055`"}], ",", 
       RowBox[{"-", "2.1000000000000005`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2.737499999999985`", ",", "0.2625000000000458`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"5.737500000000029`", ",", 
       RowBox[{"-", "2.7374999999999754`"}]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.528617770597302*^9, {3.531048470680123*^9, 3.531048482468289*^9}, {
   3.531567510265625*^9, 3.53156752328125*^9}, 3.531648847127336*^9, 
   3.531648906841684*^9, 3.53217290040657*^9, 3.532173124304222*^9, 
   3.5321731769584503`*^9, 3.5389111045625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.528617770597302*^9, {3.531048470680123*^9, 3.531048482468289*^9}, {
   3.531567510265625*^9, 3.53156752328125*^9}, 3.531648847127336*^9, 
   3.531648906841684*^9, 3.53217290040657*^9, 3.532173124304222*^9, 
   3.5321731769584503`*^9, 3.5389111045625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.528617770597302*^9, {3.531048470680123*^9, 3.531048482468289*^9}, {
   3.531567510265625*^9, 3.53156752328125*^9}, 3.531648847127336*^9, 
   3.531648906841684*^9, 3.53217290040657*^9, 3.532173124304222*^9, 
   3.5321731769584503`*^9, 3.5389111045625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TRAPToTMAP"}]], "Input",
 CellChangeTimes->{{3.532086234403899*^9, 3.532086269382534*^9}, {
  3.532163293887372*^9, 3.532163304980625*^9}}],

Cell[BoxData[
 StyleBox["\<\"TRAPToTMAP [ vector, matrix0, matrix1 ] -> [ vector, matrix0, \
matrix1 ] : Similarity transforms the non-Markovian representation of a \
transient rational arrival process to the Markovian representation of the \
same size if possibe\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5321731856143675`*^9},
 CellTags->"Info3532176785-9396620"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Beta]", ",", "g0", ",", "g1"}], "}"}], "=", 
  RowBox[{"TRAPToTMAP", "[", 
   RowBox[{"\[Beta]", ",", "g0", ",", "g1"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", " ", "-", 
   RowBox[{"MomentsFromTRAP", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "g1"}], "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "-", 
   RowBox[{"LagkJointMomentsFromTRAP", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "g1", ",", "1"}], "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{
  3.5321730835089135`*^9, {3.532173119195043*^9, 3.5321731213512106`*^9}, {
   3.532173202035612*^9, 3.532173204113657*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"No MARKOVIAN representation is found in \"\>", 
   "\[InvisibleSpace]", "27", 
   "\[InvisibleSpace]", "\<\" iterations !!!\"\>"}],
  SequenceForm[
  "No MARKOVIAN representation is found in ", 27, " iterations !!!"],
  Editable->False]], "Print",
 CellChangeTimes->{3.538911111203125*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.41942918091080567`", ",", "0.5805708190891813`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5.905024797453059`"}], ",", "0.7479927319125541`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.24188753215912046`", ",", 
       RowBox[{"-", "4.094975202547073`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.02328259387289972`"}], ",", "3.0232825938728642`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.976717406127188`", ",", "0.023282593872909874`"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.538911111203125*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.538911111203125*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.538911111203125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "d1"}], "}"}], "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.3", ",", " ", "0.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "5"}], "+", "x"}], ",", "  ", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", 
         RowBox[{"-", "9"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", "x"}], ",", "  ", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", " ", "3"}], "}"}]}], "}"}]}], "}"}], "/.", 
   RowBox[{"x", "\[Rule]", "1.2"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "=", 
   RowBox[{"MomentsFromTRAP", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "d1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", "=", 
   RowBox[{"LagkJointMomentsFromTRAP", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "d1", ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Beta]", ",", "g0", ",", "g1"}], "}"}], "=", 
  RowBox[{"TRAPToTMAP", "[", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "d1"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", " ", "-", 
   RowBox[{"MomentsFromTRAP", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "g1"}], "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "-", 
   RowBox[{"LagkJointMomentsFromTRAP", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "g1", ",", "1"}], "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.532173243299652*^9, 3.5321733083909025`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.3`", ",", "0.7`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3.8`"}], ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "9"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.19999999999999996`"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.532086276883761*^9, 3.5321733093439913`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"MARKOVIAN REPRESEANTAION !!!!!\"\>"], "Print",
 CellChangeTimes->{3.532086277027609*^9, 3.5321733093752403`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Found a Markovian representation in \"\>", "\[InvisibleSpace]",
    "5", "\[InvisibleSpace]", "\<\" iterations !!!\"\>"}],
  SequenceForm["Found a Markovian representation in ", 5, " iterations !!!"],
  Editable->False]], "Print",
 CellChangeTimes->{3.532086277027609*^9, 3.5321733093752403`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.375`", ",", "0.625`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3.3000000000000003`"}], ",", "0.4600000000000001`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.5`", ",", 
       RowBox[{"-", "9.5`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.30000000000000004`", ",", "1.34`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.5`", ",", "2.5`"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.532086276883761*^9, 3.5321733093908644`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.532086276883761*^9, 3.5321733093908644`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.532086276883761*^9, 3.5321733093908644`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
     "===", "===", "===", "===", "===", "==="}], "=", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "MARKOVIAN", " ", "BINARY", " ", "TREE", " ", "RELATED", " ", 
     "FUNCTIONS"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "===", "===",
     "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
     "===", "===", "===", "===", "=="}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.5321633124021673`*^9, 3.5321633845551853`*^9}, {
  3.532173610488677*^9, 3.532173640503149*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RBTMinimize"}]], "Input",
 CellChangeTimes->{{3.530963274797804*^9, 3.530963277299097*^9}, {
  3.54616889584375*^9, 3.546168896109375*^9}, {3.546169290875*^9, 
  3.54616929696875*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPMinimize [ vector of matrix0, matrix1, ... matrixK ] -> [ \
vector of matrix0, matrix1, ... matrixK ] : Computes a minimal representation \
of an MRAP using the staircase method by eliminating the redundancy caused by \
the initial vector and by the closing vector.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.53217085765689*^9},
 CellTags->"Info3532174457-7921268"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RBTObsMinimize"}]], "Input",
 CellChangeTimes->{{3.530963284047641*^9, 3.530963285668582*^9}, {
  3.546168898734375*^9, 3.546168899*^9}, {3.546169301734375*^9, 
  3.546169303234375*^9}}],

Cell[BoxData[
 StyleBox["\<\"MRAPObsMinimize [ vector of matrix0, matrix1, ... matrixK ] -> \
[ vector of matrix0, matrix1, ... matrixK ] : Computes a minimal \
representation of an MRAP using the staircase methor by eliminating the \
redundancy caused by the initial vector.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellChangeTimes->{3.532170859734935*^9},
 CellTags->"Info3532174459-6645394"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RBTContMinimize"}]], "Input",
 CellChangeTimes->{{3.530963290860687*^9, 3.530963293763778*^9}, {
  3.5461689020625*^9, 3.546168902359375*^9}, {3.54616930609375*^9, 
  3.546169307859375*^9}}],

Cell[BoxData[
 StyleBox["\<\"RBTContMinimize [  vector (1 x n), matrix0 (n x n), matrix1 (n \
x n^2) ] -> [  vector (1 x n), matrix0 (n x n), matrix1 (n x n^2) ] : \
Computes a minimal representation of an RBT using the staircase methor by \
eliminating the redundancy caused by the closing vector.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5461693088125*^9},
 CellTags->"Info3546176508-4270383"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"non", "-", 
    RowBox[{
    "minimal", " ", "by", " ", "the", " ", "closing", " ", "vector"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Alpha]", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "7"}], "}"}], "/", "10"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"D0", "=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"-", "24"}], "8", "1"},
        {"4", 
         RowBox[{"-", "20"}], "1"},
        {"1", "2", 
         RowBox[{"-", "21"}]}
       }], ")"}]}], ";", 
    RowBox[{"B", "=", 
     RowBox[{"(", GridBox[{
        {"1", "2", "2", "1", "1", "2", "0", "3", "2"},
        {"2", "0", "1", "1", "2", "3", "1", "2", "2"},
        {"1", "1", "4", "1", "1", "2", "2", "1", "4"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "}"}], "=", 
    RowBox[{"RBTContMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "}"}], "=", 
    RowBox[{"RBTObsMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5461689048125*^9, 3.54616900075*^9}, {
  3.546169047421875*^9, 3.546169055859375*^9}, {3.54616909246875*^9, 
  3.5461691590625*^9}, {3.546169333109375*^9, 3.54616935975*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.2221825406947976`", ",", "0.7778174593052022`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "13.878679656440362`"}], ",", 
       RowBox[{"-", "2.1213203435596384`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5.707106781186546`", ",", 
       RowBox[{"-", "23.121320343559642`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "8.636038969321072`", ",", "4.949747468305831`", ",", 
       "1.4142135623730925`", ",", "1.7763568394002505`*^-15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "6.757359312880712`", ",", "7.242640687119286`", ",", 
       "1.7071067811865492`", ",", "0.7071067811865452`"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.5461690620625*^9, 
  3.5461693608125*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", "10"], ",", 
     FractionBox["1", "5"], ",", 
     FractionBox["7", "10"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "24"}], ",", "8", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"-", "20"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "21"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "2", ",", "1", ",", "1", ",", "2", ",", "0", ",", 
       "3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "0", ",", "1", ",", "1", ",", "2", ",", "3", ",", "1", ",", 
       "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "4", ",", "1", ",", "1", ",", "2", ",", "2", ",", 
       "1", ",", "4"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.5461690620625*^9, 
  3.54616936084375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "}"}], "=", 
  RowBox[{"RBTContMinimize", "[", 
   RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "=", 
   RowBox[{
    RowBox[{"MomentsFromRBT", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", "=", 
   RowBox[{
    RowBox[{"GammaijkMomentsFromRBT", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom1", "=", 
   RowBox[{
    RowBox[{"MomentsFromRBT", "[", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nn1", "=", 
    RowBox[{
     RowBox[{"GammaijkMomentsFromRBT", "[", 
      RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "]"}], "//", "N"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mom", "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "4"}], "]"}], "]"}], "-", "mom1"}], " ", "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"size", "=", "3"}], ";", " ", 
   RowBox[{"n", "=", "2"}], ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn3D", " ", "=", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"nn", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"j", "-", "1"}], ")"}], " ", "size"}], " ", "+", " ", 
         "k"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "size"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "size"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "size"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn3D", " ", "=", " ", 
   RowBox[{"nn3D", " ", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", ";;", "n"}], ",", 
      RowBox[{"1", ";;", "n"}], " ", ",", 
      RowBox[{"1", ";;", "n"}]}], " ", "]"}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "=", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"nn3D", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", 
        RowBox[{
         RowBox[{"Floor", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"j", "-", "1"}], ")"}], "/", "n"}], "]"}], "+", "1"}], 
        ",", 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"j", "-", "1"}], ",", "n"}], "]"}], "+", "1"}]}], " ", 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", 
       RowBox[{"n", "^", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", "-", "nn1"}], " ", "//", "Chop"}]}], "Input",
 CellChangeTimes->{{3.546169027046875*^9, 3.546169059984375*^9}, {
   3.5461692374375*^9, 3.546169241796875*^9}, 3.546169401390625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.2221825406947976`", ",", "0.7778174593052022`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "13.878679656440362`"}], ",", 
       RowBox[{"-", "2.1213203435596384`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5.707106781186546`", ",", 
       RowBox[{"-", "23.121320343559642`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "8.636038969321072`", ",", "4.949747468305831`", ",", 
       "1.4142135623730925`", ",", "1.7763568394002505`*^-15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "6.757359312880712`", ",", "7.242640687119286`", ",", 
       "1.7071067811865492`", ",", "0.7071067811865452`"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.54616924246875*^9, 
  3.54616940421875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.54616924246875*^9, 
  3.546169404265625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5461690741875*^9, 3.54616924246875*^9, 
  3.546169404296875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"non", "-", 
    RowBox[{
    "minimal", " ", "by", " ", "the", " ", "initial", " ", "vector"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Alpha]", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "2"}], "}"}], "/", "4"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"D0", "=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"-", "25"}], "4", "3"},
        {"4", 
         RowBox[{"-", "25"}], "1"},
        {"1", "1", 
         RowBox[{"-", "31"}]}
       }], ")"}]}], ";", 
    RowBox[{"B", "=", 
     RowBox[{"(", GridBox[{
        {"1", "2", "3", "0", 
         RowBox[{"3", "/", "2"}], "0", "2", "1", "0"},
        {"2", "1", "1", "3", 
         RowBox[{"3", "/", "2"}], "4", "0", "1", "2"},
        {"3", "3", "4", "3", "3", "4", "2", "2", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "}"}], "=", 
    RowBox[{"RBTContMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "}"}], "=", 
    RowBox[{"RBTObsMinimize", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5461689048125*^9, 3.54616900075*^9}, {
  3.546169047421875*^9, 3.546169055859375*^9}, {3.54616909246875*^9, 
  3.5461691590625*^9}, {3.546169333109375*^9, 3.54616935975*^9}, {
  3.546169444953125*^9, 3.546169477484375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", "4"], ",", 
     FractionBox["1", "4"], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "25"}], ",", "4", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"-", "25"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", 
       RowBox[{"-", "31"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "0", ",", 
       FractionBox["3", "2"], ",", "0", ",", "2", ",", "1", ",", "0"}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1", ",", "3", ",", 
       FractionBox["3", "2"], ",", "4", ",", "0", ",", "1", ",", "2"}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "3", ",", "4", ",", "3", ",", "3", ",", "4", ",", "2", ",", 
       "2", ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.5461690620625*^9, 
  3.5461693608125*^9, 3.546169478453125*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9999999999999999`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "25.666666666666664`"}], ",", "1.666666666666667`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"17.33333333333333`", ",", 
       RowBox[{"-", "26.333333333333336`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "13.777777777777779`", ",", "1.5555555555555556`", ",", 
       "3.5555555555555554`", ",", "0.11111111111111127`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7777777777777706`", ",", 
       RowBox[{"-", "0.4444444444444443`"}], ",", 
       RowBox[{"-", "0.4444444444444461`"}], ",", "0.11111111111111073`"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.54616900478125*^9, 3.5461690620625*^9, 
  3.5461693608125*^9, 3.54616947846875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "}"}], "=", 
  RowBox[{"RBTMinimize", "[", 
   RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "=", 
   RowBox[{
    RowBox[{"MomentsFromRBT", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", "=", 
   RowBox[{
    RowBox[{"GammaijkMomentsFromRBT", "[", 
     RowBox[{"\[Alpha]", ",", "D0", ",", "B"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom1", "=", 
   RowBox[{
    RowBox[{"MomentsFromRBT", "[", 
     RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "]"}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nn1", "=", 
    RowBox[{
     RowBox[{"GammaijkMomentsFromRBT", "[", 
      RowBox[{"\[Gamma]", ",", "G0", ",", "H"}], "]"}], "//", "N"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mom", "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "4"}], "]"}], "]"}], "-", "mom1"}], " ", "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"size", "=", "3"}], ";", " ", 
   RowBox[{"n", "=", "2"}], ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn3D", " ", "=", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"nn", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"j", "-", "1"}], ")"}], " ", "size"}], " ", "+", " ", 
         "k"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "size"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "size"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "size"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn3D", " ", "=", " ", 
   RowBox[{"nn3D", " ", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", ";;", "n"}], ",", 
      RowBox[{"1", ";;", "n"}], " ", ",", 
      RowBox[{"1", ";;", "n"}]}], " ", "]"}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "=", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"nn3D", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", 
        RowBox[{
         RowBox[{"Floor", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"j", "-", "1"}], ")"}], "/", "n"}], "]"}], "+", "1"}], 
        ",", 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"j", "-", "1"}], ",", "n"}], "]"}], "+", "1"}]}], " ", 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", 
       RowBox[{"n", "^", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", "-", "nn1"}], " ", "//", "Chop"}]}], "Input",
 CellChangeTimes->{{3.546169027046875*^9, 3.546169059984375*^9}, {
   3.5461692374375*^9, 3.546169241796875*^9}, 3.546169401390625*^9, {
   3.54616950240625*^9, 3.546169502953125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9999999999999999`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "25.666666666666664`"}], ",", "1.666666666666667`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"17.33333333333333`", ",", 
       RowBox[{"-", "26.333333333333336`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "13.777777777777779`", ",", "1.5555555555555556`", ",", 
       "3.5555555555555554`", ",", "0.11111111111111127`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7777777777777706`", ",", 
       RowBox[{"-", "0.4444444444444443`"}], ",", 
       RowBox[{"-", "0.4444444444444461`"}], ",", "0.11111111111111073`"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5461690741875*^9, 3.54616924246875*^9, 3.54616940421875*^9, {
   3.5461694879375*^9, 3.546169503328125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5461690741875*^9, 3.54616924246875*^9, 3.54616940421875*^9, {
   3.5461694879375*^9, 3.546169503375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5461690741875*^9, 3.54616924246875*^9, 3.54616940421875*^9, {
   3.5461694879375*^9, 3.546169503390625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MomentsFromRBT"}]], "Input",
 CellChangeTimes->{{3.52853432842734*^9, 3.528534330996492*^9}, {
  3.531048401111373*^9, 3.531048401451096*^9}}],

Cell[BoxData[
 StyleBox["\<\"MomentsFromRBT [ vector (1 x n), matrix0 (n x n), matrix1 (n x \
n^2) ] -> [ moments ] : returns: defective moments of X0^i for i=0 to 2n-1.\"\
\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5321733585921*^9},
 CellTags->"Info3532176958-1173351"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GammaijkMomentsFromRBT"}]], "Input",
 CellChangeTimes->{{3.528534334863671*^9, 3.528534342716213*^9}, {
  3.531048406641853*^9, 3.53104840686847*^9}}],

Cell[BoxData[
 StyleBox["\<\"GammaijkMomentsFromRBT [ vector (1 x n), matrix0 (n x n), \
matrix1 (n x n^2) ] -> [ moments ] : calculates the defective joint moments \
of X0^i X1^j Y0^k for i,j,k=0 to n-1 and returns them in an n x n^2 matrix.\"\
\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5321733593889446`*^9},
 CellTags->"Info3532176959-7497306"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RBTFromMoments"}]], "Input",
 CellChangeTimes->{{3.528617543045519*^9, 3.528617554989247*^9}, {
  3.531048413845803*^9, 3.531048414130793*^9}, {3.5321633928048153`*^9, 
  3.532163394289124*^9}}],

Cell[BoxData[
 StyleBox["\<\"RBTFromMoments [  vector (1 x 2n), matrix0 (n x n^2) ] -> [ \
vector (1 x n), matrix0 (n x n), matrix1 (n x n^2) ] : input: X0^i defective \
moments for i=0 to 2n-1 + defective joint moments of X0^i X1^j Y0^k for \
i,j,k=0 to n-1. It returns a representation of the MBT. \"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5321733615763607`*^9},
 CellTags->"Info3532176961-1707885"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"{", "1.", "}"}]}], ";", 
  RowBox[{"d0", "=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"-", "1."}], "}"}], "}"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"{", 
    RowBox[{"{", "0.9", "}"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"{", 
    RowBox[{".6", ",", ".4"}], "}"}]}], ";", 
  RowBox[{"d0", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "4."}], "0"},
      {"1", 
       RowBox[{"-", "6"}]}
     }], ")"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"(", GridBox[{
      {"1", "1", "0", "1"},
      {"3", "0", "1", "0"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{"{", 
    RowBox[{".1", ",", ".5", ",", ".4"}], "}"}]}], ";", 
  RowBox[{"d0", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "14."}], "0", "1"},
      {"1", 
       RowBox[{"-", "6"}], "0"},
      {"1", "0", 
       RowBox[{"-", "3"}]}
     }], ")"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"(", GridBox[{
      {"1", "1", "0", "1", "2", "0", "0", "0", "1"},
      {"1", "0", "1", "0", "0", "1", "1", "0", "0"},
      {"0", "0", "0", "0", "0", "0", "0", "0", "1"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"mom", "=", 
  RowBox[{"MomentsFromRBT", "[", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"nn", "=", 
  RowBox[{"GammaijkMomentsFromRBT", "[", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.531048418071029*^9, 3.531048420671071*^9}, {
  3.5321634127726707`*^9, 3.532163413335146*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.6134146341463415`", ",", "0.1415377751338489`", ",", 
   "0.07423874194125642`", ",", "0.06502721597238174`", ",", 
   "0.08171781042125185`", ",", "0.1340245513023368`"}], "}"}]], "Output",
 CellChangeTimes->{3.528606812193808*^9, 3.528617075893713*^9, 
  3.531048421587827*^9, 3.531648881069761*^9, 3.532163440740168*^9, 
  3.532173372544689*^9, 3.538911453546875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.1714870407181169`", ",", "0.04300784225323137`", ",", 
     "0.02610521396836297`", ",", "0.03733165744260278`", ",", 
     "0.00981028792393541`", ",", "0.006125097850685956`", ",", 
     "0.0203240377746855`", ",", "0.005456558669755777`", ",", 
     "0.003467259000183989`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.03981410917074886`", ",", "0.01029929459230624`", ",", 
     "0.0062815457479183014`", ",", "0.009353263790534807`", ",", 
     "0.0026279503287507154`", ",", "0.0016727826658139515`", ",", 
     "0.005318016382305389`", ",", "0.0015613594689922552`", ",", 
     "0.0010177735405305852`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.021009472437078052`", ",", "0.005588392908998356`", ",", 
     "0.0034221349284160813`", ",", "0.0052730493084078775`", ",", 
     "0.00155903721162196`", ",", "0.0010059744734920416`", ",", 
     "0.003100958473211778`", ",", "0.0009688334078848094`", ",", 
     "0.0006417658837735832`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.528606812193808*^9, 3.528617075893713*^9, 
  3.531048421587827*^9, 3.531648881069761*^9, 3.532163440740168*^9, 
  3.532173372544689*^9, 3.5389114535625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Beta]", ",", "g0", ",", "gg"}], "}"}], "=", 
  RowBox[{"RBTFromMoments", "[", 
   RowBox[{"mom", ",", "nn"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "-", 
   RowBox[{"MomentsFromRBT", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "gg"}], "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "-", 
   RowBox[{"GammaijkMomentsFromRBT", "[", 
    RowBox[{"\[Beta]", ",", "g0", ",", "gg"}], "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.531048424814284*^9, 3.531048428917839*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.2847256197437812`", ",", "0.35747206117448593`", ",", 
     "0.3578023828004231`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "6.076788484739994`"}], ",", "24.71046819508098`", ",", 
       RowBox[{"-", "24.64197080753285`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1.140685026555969`"}], ",", 
       RowBox[{"-", "8.465607573576973`"}], ",", "5.573463499881194`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1.1595525731045948`"}], ",", "5.571173697881955`", ",", 
       RowBox[{"-", "8.457603941646154`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.34926756843839524`"}], ",", 
       RowBox[{"-", "194.53097534635413`"}], ",", "197.6109080990292`", ",", 
       RowBox[{"-", "278.34273475019927`"}], ",", "224684.30093258442`", ",", 
       
       RowBox[{"-", "225331.89923256324`"}], ",", "279.9020860254741`", ",", 
       RowBox[{"-", "225434.9088294756`"}], ",", "226082.52887736988`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.46306083217028515`", ",", 
       RowBox[{"-", "135.80937343419046`"}], ",", "136.14623037988412`", ",", 
       
       RowBox[{"-", "166.8844994047399`"}], ",", "94800.52282088042`", ",", 
       RowBox[{"-", "94989.25916576048`"}], ",", "166.65756600292815`", ",", 
       RowBox[{"-", "95027.45232890302`"}], ",", "95218.09208522017`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47484428325942485`", ",", 
       RowBox[{"-", "137.14545317920522`"}], ",", "137.4731443870965`", ",", 
       RowBox[{"-", "168.04578740546896`"}], ",", "94736.61684965473`", ",", 
       RowBox[{"-", "94923.78450914877`"}], ",", "167.81285948062433`", ",", 
       RowBox[{"-", "94961.76284292512`"}], ",", "95150.84016258034`"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.52861708328507*^9, 3.528617087426599*^9}, 
   3.531048433358423*^9, 3.531648886103925*^9, 3.532163445927436*^9, 
   3.5321733827161736`*^9, 3.538911457921875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.52861708328507*^9, 3.528617087426599*^9}, 
   3.531048433358423*^9, 3.531648886103925*^9, 3.532163445927436*^9, 
   3.5321733827161736`*^9, 3.5389114579375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1.0572565878330664`*^-9", ",", "1.841579944095173`*^-10", ",", 
     "1.4715218626948356`*^-10", ",", "1.871669208508564`*^-10", ",", "0", 
     ",", "0", ",", "1.5063539304804863`*^-10", ",", "0", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
    "1.8761188436133835`*^-10", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.52861708328507*^9, 3.528617087426599*^9}, 
   3.531048433358423*^9, 3.531648886103925*^9, 3.532163445927436*^9, 
   3.5321733827161736`*^9, 3.53891145796875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RBTToMBT"}]], "Input",
 CellChangeTimes->{{3.532086297125828*^9, 3.532086297393641*^9}}],

Cell[BoxData[
 StyleBox["\<\"RBTToTMAP [ vector, matrix0, matrix1 ] -> [ vector, matrix0, \
matrix1 ] : Similarity transforms the non-Markovian representation of a \
rational binary tree process to a Markovian representation of the same size \
if possible.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.538911461984375*^9},
 CellTags->"Info3538915061-4073966"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "}"}], "=", 
  RowBox[{"RBTToMBT", "[", 
   RowBox[{"\[Beta]", ",", "g0", ",", "gg"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "-", 
   RowBox[{"MomentsFromRBT", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "-", 
   RowBox[{"GammaijkMomentsFromRBT", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "]"}]}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.532163478879084*^9, 3.53216349437839*^9}, {
  3.5321635781402617`*^9, 3.5321635926552367`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"No MARKOVIAN representation is found in \"\>", 
   "\[InvisibleSpace]", "47", 
   "\[InvisibleSpace]", "\<\" iterations !!!\"\>"}],
  SequenceForm[
  "No MARKOVIAN representation is found in ", 47, " iterations !!!"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5321635069403267`*^9, 3.532163594389534*^9, 
  3.5321734414639177`*^9, 3.538911467546875*^9, 3.53891203721875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.5620156232292376`", ",", "0.3901600189020163`", ",", 
     "0.04782442158743649`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "6.0026889392899285`"}], ",", "0.02146049376246052`", ",",
        "0.22579928871106858`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.2283169457813965`", ",", 
       RowBox[{"-", "2.938282302735516`"}], ",", "0.8699925447951762`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.18427136324062987`", ",", "0.3361619126614036`", ",", 
       RowBox[{"-", "14.059028757937675`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.26468805751582497`", ",", "0.9426028652343262`", ",", 
       "0.11358906569866285`", ",", "0.004848422248379211`", ",", 
       "0.17124323432242794`", ",", "0.8981951967833491`", ",", 
       "0.11897903118215436`", ",", "0.8219046357368252`", ",", 
       "0.9097946200289899`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.013660349832161788`", ",", "0.0018618389164534914`", ",", 
       "0.0005268369756947595`", ",", "0.07699386712986091`", ",", 
       "0.9331827893386846`", ",", 
       RowBox[{"-", "0.08277158821160654`"}], ",", "0.00009499784907051993`", 
       ",", 
       RowBox[{"-", "0.07665925823857139`"}], ",", 
       RowBox[{"-", "0.06291922511177707`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "2.351135568793865`", ",", "0.19300520574546698`", ",", 
       "0.861114024358874`", ",", "0.17469719939754869`", ",", 
       "0.8692248044795371`", ",", "0.07396750646535274`", ",", 
       "0.8612192542572098`", ",", "0.07247806739130548`", ",", 
       "0.8180176569243449`"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5321635069403267`*^9, 3.532163594405158*^9, 
  3.5321734414639177`*^9, 3.538911467546875*^9, 3.538912037234375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5321635069403267`*^9, 3.532163594405158*^9, 
  3.5321734414639177`*^9, 3.538911467546875*^9, 3.538912037234375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "9.895145258731475`*^-10", ",", "1.8267710955033323`*^-10", ",", "0", ",",
      "1.8560267212031079`*^-10", ",", "0", ",", "0", ",", "0", ",", "0", ",",
      "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1.7665585660964211`*^-10", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5321635069403267`*^9, 3.532163594405158*^9, 
  3.5321734414639177`*^9, 3.538911467546875*^9, 3.538912037234375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "}"}], "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.3", ",", " ", "0.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "5"}], "+", "x"}], ",", "  ", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", 
         RowBox[{"-", "9"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", "x"}], ",", "  ", 
         RowBox[{"1", "/", "2"}], ",", " ", "0", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", " ", "2", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
    "}"}], "/.", 
   RowBox[{"x", "\[Rule]", "1.6"}]}]}], "\n", 
 RowBox[{
  RowBox[{"mom", "=", 
   RowBox[{"MomentsFromRBT", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "=", 
   RowBox[{"GammaijkMomentsFromRBT", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "}"}], "=", 
  RowBox[{"RBTToMBT", "[", 
   RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mom", "-", 
   RowBox[{"MomentsFromRBT", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nn", " ", "-", 
   RowBox[{"GammaijkMomentsFromRBT", "[", 
    RowBox[{"\[Alpha]", ",", "d0", ",", "b"}], "]"}]}], "//", 
  "Chop"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5321636623239903`*^9, 3.5321636910883265`*^9}, {
  3.532173465728611*^9, 3.532173472493976*^9}, {3.53891208875*^9, 
  3.538912097125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.3`", ",", "0.7`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3.4`"}], ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "9"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.6000000000000001`"}], ",", 
       FractionBox["1", "2"], ",", "0", ",", 
       FractionBox["1", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.532086307654686*^9, 3.5321636945569215`*^9, {3.5321734512604165`*^9, 
   3.532173472962708*^9}, {3.5389120733125*^9, 3.538912097828125*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"MARKOVIAN REPRESEANTAION !!!!!\"\>"], "Print",
 CellChangeTimes->{
  3.532086307807033*^9, 3.532163694603794*^9, {3.5321734513072896`*^9, 
   3.532173473009581*^9}, {3.538912073359375*^9, 3.538912097875*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Found a Markovian representation in \"\>", "\[InvisibleSpace]",
    "11", "\[InvisibleSpace]", "\<\" iterations !!!\"\>"}],
  SequenceForm["Found a Markovian representation in ", 11, " iterations !!!"],
  
  Editable->False]], "Print",
 CellChangeTimes->{
  3.532086307807033*^9, 3.532163694603794*^9, {3.5321734513072896`*^9, 
   3.532173473009581*^9}, {3.538912073359375*^9, 3.538912097875*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.58984375`", ",", "0.41015625`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2.769375`"}], ",", "0.24937500000000007`"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"0.2839583333333333`", ",", 
       RowBox[{"-", "9.630624999999998`"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.09163330078124989`", ",", "0.78867919921875`", ",", 
       "0.29649169921875007`", ",", "0.14319580078125002`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "4.026127348400297`", ",", "1.8818041992187498`", ",", 
       "0.8896166992187499`", ",", "0.13007080078124997`"}], "}"}]}], "}"}]}],
   "}"}]], "Output",
 CellChangeTimes->{
  3.532086307654686*^9, 3.5321636945569215`*^9, {3.5321734512604165`*^9, 
   3.532173472962708*^9}, {3.5389120733125*^9, 3.538912097875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.532086307654686*^9, 3.5321636945569215`*^9, {3.5321734512604165`*^9, 
   3.532173472962708*^9}, {3.5389120733125*^9, 3.538912097875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.532086307654686*^9, 3.5321636945569215`*^9, {3.5321734512604165`*^9, 
   3.532173472962708*^9}, {3.5389120733125*^9, 3.538912097875*^9}}]
}, Open  ]]
},
WindowSize->{640, 750},
WindowMargins->{{Automatic, 168}, {Automatic, 25}},
ShowSelection->True,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (February 7, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3532174457-7921268"->{
  Cell[7933, 187, 416, 7, 75, "Print",
   CellTags->"Info3532174457-7921268"],
  Cell[49006, 1329, 416, 7, 75, "Print",
   CellTags->"Info3532174457-7921268"],
  Cell[76101, 2182, 416, 7, 75, "Print",
   CellTags->"Info3532174457-7921268"]},
 "Info3532174459-6645394"->{
  Cell[8513, 203, 394, 7, 75, "Print",
   CellTags->"Info3532174459-6645394"],
  Cell[49629, 1346, 394, 7, 75, "Print",
   CellTags->"Info3532174459-6645394"],
  Cell[76772, 2200, 394, 7, 75, "Print",
   CellTags->"Info3532174459-6645394"]},
 "Info3532174460-6629914"->{
  Cell[9072, 219, 397, 7, 75, "Print",
   CellTags->"Info3532174460-6629914"],
  Cell[50235, 1363, 397, 7, 75, "Print",
   CellTags->"Info3532174460-6629914"]},
 "Info3532174472-7773575"->{
  Cell[9628, 235, 325, 5, 58, "Print",
   CellTags->"Info3532174472-7773575"]},
 "Info3532175020-7332988"->{
  Cell[18861, 539, 435, 7, 75, "Print",
   CellTags->"Info3532175020-7332988"]},
 "Info3532175022-1876917"->{
  Cell[19459, 555, 292, 5, 58, "Print",
   CellTags->"Info3532175022-1876917"]},
 "Info3532174628-1638735"->{
  Cell[19914, 569, 420, 7, 75, "Print",
   CellTags->"Info3532174628-1638735"]},
 "Info3538914439-9668823"->{
  Cell[31758, 869, 408, 7, 75, "Print",
   CellTags->"Info3538914439-9668823"]},
 "Info3531652501-7249867"->{
  Cell[62378, 1767, 285, 5, 58, "Print",
   CellTags->"Info3531652501-7249867"]},
 "Info3532175684-9722049"->{
  Cell[63062, 1784, 313, 5, 58, "Print",
   CellTags->"Info3532175684-9722049"]},
 "Info3532167514-2990213"->{
  Cell[63592, 1799, 359, 6, 58, "Print",
   CellTags->"Info3532167514-2990213"]},
 "Info3532176785-9396620"->{
  Cell[68649, 1946, 382, 6, 75, "Print",
   CellTags->"Info3532176785-9396620"]},
 "Info3546176508-4270383"->{
  Cell[77425, 2218, 416, 7, 75, "Print",
   CellTags->"Info3546176508-4270383"]},
 "Info3532176958-1173351"->{
  Cell[94542, 2758, 286, 5, 58, "Print",
   CellTags->"Info3532176958-1173351"]},
 "Info3532176959-7497306"->{
  Cell[95047, 2773, 363, 6, 58, "Print",
   CellTags->"Info3532176959-7497306"]},
 "Info3532176961-1707885"->{
  Cell[95673, 2790, 422, 7, 75, "Print",
   CellTags->"Info3532176961-1707885"]},
 "Info3538915061-4073966"->{
  Cell[103548, 3005, 373, 6, 75, "Print",
   CellTags->"Info3538915061-4073966"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3532174457-7921268", 113371, 3288},
 {"Info3532174459-6645394", 113642, 3295},
 {"Info3532174460-6629914", 113913, 3302},
 {"Info3532174472-7773575", 114103, 3307},
 {"Info3532175020-7332988", 114212, 3310},
 {"Info3532175022-1876917", 114322, 3313},
 {"Info3532174628-1638735", 114432, 3316},
 {"Info3538914439-9668823", 114542, 3319},
 {"Info3531652501-7249867", 114652, 3322},
 {"Info3532175684-9722049", 114763, 3325},
 {"Info3532167514-2990213", 114874, 3328},
 {"Info3532176785-9396620", 114985, 3331},
 {"Info3546176508-4270383", 115096, 3334},
 {"Info3532176958-1173351", 115207, 3337},
 {"Info3532176959-7497306", 115318, 3340},
 {"Info3532176961-1707885", 115429, 3343},
 {"Info3538915061-4073966", 115540, 3346}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 613, 15, 92, "Input"],
Cell[CellGroupData[{
Cell[1206, 40, 157, 2, 52, "Input"],
Cell[1366, 44, 1368, 23, 107, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2771, 72, 143, 2, 52, "Input"],
Cell[2917, 76, 1058, 18, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4012, 99, 145, 2, 52, "Input"],
Cell[4160, 103, 968, 17, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5165, 125, 288, 5, 52, "Input"],
Cell[5456, 132, 1333, 23, 126, "Output"]
}, Open  ]],
Cell[6804, 158, 980, 21, 112, "Input"],
Cell[CellGroupData[{
Cell[7809, 183, 121, 2, 31, "Input"],
Cell[7933, 187, 416, 7, 75, "Print",
 CellTags->"Info3532174457-7921268"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8386, 199, 124, 2, 31, "Input"],
Cell[8513, 203, 394, 7, 75, "Print",
 CellTags->"Info3532174459-6645394"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8944, 215, 125, 2, 31, "Input"],
Cell[9072, 219, 397, 7, 75, "Print",
 CellTags->"Info3532174460-6629914"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9506, 231, 119, 2, 31, "Input"],
Cell[9628, 235, 325, 5, 58, "Print",
 CellTags->"Info3532174472-7773575"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9990, 245, 965, 34, 101, "Input"],
Cell[10958, 281, 691, 17, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11686, 303, 537, 14, 92, "Input"],
Cell[12226, 319, 787, 23, 30, "Output"],
Cell[13016, 344, 748, 22, 50, "Output"],
Cell[13767, 368, 746, 22, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14550, 395, 1029, 36, 141, "Input"],
Cell[15582, 433, 1012, 31, 50, "Output"],
Cell[16597, 466, 1044, 31, 69, "Output"],
Cell[17644, 499, 1042, 31, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18723, 535, 135, 2, 31, "Input"],
Cell[18861, 539, 435, 7, 75, "Print",
 CellTags->"Info3532175020-7332988"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19333, 551, 123, 2, 31, "Input"],
Cell[19459, 555, 292, 5, 58, "Print",
 CellTags->"Info3532175022-1876917"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19788, 565, 123, 2, 31, "Input"],
Cell[19914, 569, 420, 7, 75, "Print",
 CellTags->"Info3532174628-1638735"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20371, 581, 2604, 70, 212, "Input"],
Cell[22978, 653, 712, 13, 30, "Output"],
Cell[23693, 668, 1979, 47, 164, "Output"],
Cell[25675, 717, 3046, 75, 202, "Output"],
Cell[28724, 794, 728, 13, 33, "Output"],
Cell[29455, 809, 2140, 51, 187, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31632, 865, 123, 2, 31, "Input"],
Cell[31758, 869, 408, 7, 75, "Print",
 CellTags->"Info3538914439-9668823"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32203, 881, 496, 13, 72, "Input"],
Cell[32702, 896, 472, 10, 23, "Print"],
Cell[33177, 908, 2727, 68, 240, "Output"],
Cell[CellGroupData[{
Cell[35929, 980, 495, 11, 23, "Print"],
Cell[36427, 993, 243, 3, 23, "Print"]
}, Open  ]],
Cell[36685, 999, 458, 9, 33, "Output"],
Cell[37146, 1010, 1868, 47, 187, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39051, 1062, 2809, 76, 272, "Input"],
Cell[41863, 1140, 1617, 44, 88, "Output"],
Cell[CellGroupData[{
Cell[43505, 1188, 255, 3, 23, "Print"],
Cell[43763, 1193, 475, 9, 23, "Print"]
}, Open  ]],
Cell[44253, 1205, 2496, 62, 240, "Output"],
Cell[46752, 1269, 317, 6, 30, "Output"],
Cell[47072, 1277, 990, 26, 50, "Output"]
}, Open  ]],
Cell[48077, 1306, 732, 14, 112, "Input"],
Cell[CellGroupData[{
Cell[48834, 1324, 169, 3, 31, "Input"],
Cell[49006, 1329, 416, 7, 75, "Print",
 CellTags->"Info3532174457-7921268"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49459, 1341, 167, 3, 31, "Input"],
Cell[49629, 1346, 394, 7, 75, "Print",
 CellTags->"Info3532174459-6645394"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50060, 1358, 172, 3, 31, "Input"],
Cell[50235, 1363, 397, 7, 75, "Print",
 CellTags->"Info3532174460-6629914"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50669, 1375, 1378, 43, 143, "Input"],
Cell[52050, 1420, 777, 23, 50, "Output"],
Cell[52830, 1445, 846, 27, 71, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53713, 1477, 1501, 46, 152, "Input"],
Cell[55217, 1525, 766, 23, 50, "Output"],
Cell[55986, 1550, 150, 3, 30, "Output"],
Cell[56139, 1555, 228, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56404, 1567, 1372, 43, 143, "Input"],
Cell[57779, 1612, 868, 28, 71, "Output"],
Cell[58650, 1642, 818, 25, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59505, 1672, 1454, 45, 152, "Input"],
Cell[60962, 1719, 761, 23, 50, "Output"],
Cell[61726, 1744, 155, 3, 30, "Output"],
Cell[61884, 1749, 233, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62154, 1761, 221, 4, 31, "Input"],
Cell[62378, 1767, 285, 5, 58, "Print",
 CellTags->"Info3531652501-7249867"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62700, 1777, 359, 5, 31, "Input"],
Cell[63062, 1784, 313, 5, 58, "Print",
 CellTags->"Info3532175684-9722049"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63412, 1794, 177, 3, 31, "Input"],
Cell[63592, 1799, 359, 6, 58, "Print",
 CellTags->"Info3532167514-2990213"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63988, 1810, 937, 27, 105, "Input"],
Cell[64928, 1839, 446, 9, 30, "Output"],
Cell[65377, 1850, 523, 12, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65937, 1867, 668, 17, 72, "Input"],
Cell[66608, 1886, 1005, 28, 50, "Output"],
Cell[67616, 1916, 372, 7, 30, "Output"],
Cell[67991, 1925, 450, 11, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68478, 1941, 168, 3, 31, "Input"],
Cell[68649, 1946, 382, 6, 75, "Print",
 CellTags->"Info3532176785-9396620"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69068, 1957, 708, 19, 72, "Input"],
Cell[69779, 1978, 338, 8, 23, "Print"],
Cell[70120, 1988, 758, 24, 50, "Output"],
Cell[70881, 2014, 135, 3, 30, "Output"],
Cell[71019, 2019, 213, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71269, 2031, 1725, 52, 152, "Input"],
Cell[72997, 2085, 605, 20, 30, "Output"],
Cell[CellGroupData[{
Cell[73627, 2109, 130, 1, 23, "Print"],
Cell[73760, 2112, 345, 6, 23, "Print"]
}, Open  ]],
Cell[74120, 2121, 642, 20, 30, "Output"],
Cell[74765, 2143, 159, 3, 30, "Output"],
Cell[74927, 2148, 237, 7, 30, "Output"]
}, Open  ]],
Cell[75179, 2158, 681, 14, 112, "Input"],
Cell[CellGroupData[{
Cell[75885, 2176, 213, 4, 31, "Input"],
Cell[76101, 2182, 416, 7, 75, "Print",
 CellTags->"Info3532174457-7921268"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76554, 2194, 215, 4, 31, "Input"],
Cell[76772, 2200, 394, 7, 75, "Print",
 CellTags->"Info3532174459-6645394"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77203, 2212, 219, 4, 31, "Input"],
Cell[77425, 2218, 416, 7, 75, "Print",
 CellTags->"Info3546176508-4270383"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77878, 2230, 1498, 43, 143, "Input"],
Cell[79379, 2275, 920, 26, 77, "Output"],
Cell[80302, 2303, 1094, 34, 90, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[81433, 2342, 3062, 97, 272, "Input"],
Cell[84498, 2441, 921, 26, 77, "Output"],
Cell[85422, 2469, 179, 4, 30, "Output"],
Cell[85604, 2475, 297, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85938, 2488, 1606, 46, 143, "Input"],
Cell[87547, 2536, 1147, 34, 113, "Output"],
Cell[88697, 2572, 944, 26, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89678, 2603, 3107, 98, 272, "Input"],
Cell[92788, 2703, 970, 27, 69, "Output"],
Cell[93761, 2732, 223, 5, 30, "Output"],
Cell[93987, 2739, 344, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94368, 2753, 171, 3, 31, "Input"],
Cell[94542, 2758, 286, 5, 58, "Print",
 CellTags->"Info3532176958-1173351"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94865, 2768, 179, 3, 31, "Input"],
Cell[95047, 2773, 363, 6, 58, "Print",
 CellTags->"Info3532176959-7497306"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95447, 2784, 223, 4, 31, "Input"],
Cell[95673, 2790, 422, 7, 75, "Print",
 CellTags->"Info3532176961-1707885"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96132, 2802, 1671, 54, 155, "Input"],
Cell[97806, 2858, 415, 8, 30, "Output"],
Cell[98224, 2868, 1244, 26, 126, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99505, 2899, 596, 16, 72, "Input"],
Cell[100104, 2917, 2180, 50, 126, "Output"],
Cell[102287, 2969, 299, 6, 30, "Output"],
Cell[102589, 2977, 802, 19, 77, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103428, 3001, 117, 2, 31, "Input"],
Cell[103548, 3005, 373, 6, 75, "Print",
 CellTags->"Info3538915061-4073966"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103958, 3016, 661, 18, 72, "Input"],
Cell[104622, 3036, 432, 9, 23, "Print"],
Cell[105057, 3047, 1957, 46, 145, "Output"],
Cell[107017, 3095, 253, 5, 30, "Output"],
Cell[107273, 3102, 707, 17, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108017, 3124, 1902, 57, 192, "Input"],
Cell[109922, 3183, 798, 25, 45, "Output"],
Cell[CellGroupData[{
Cell[110745, 3212, 226, 3, 23, "Print"],
Cell[110974, 3217, 446, 9, 23, "Print"]
}, Open  ]],
Cell[111435, 3229, 956, 27, 69, "Output"],
Cell[112394, 3258, 255, 5, 30, "Output"],
Cell[112652, 3265, 373, 9, 30, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
